local L = LibStub("AceLocale-3.0"):GetLocale("sRaidFrames")
local Media = LibStub("LibSharedMedia-3.0")
local sRaidFrames = sRaidFrames

sRaidFrames.Layouts = {}

function sRaidFrames:RegisterLayout(name, data)
	self.Layouts[name] = data
	
	self.options.args.behaviour.args.layout.values = {}
	for _name, _data in pairs(self.Layouts) do
		self.options.args.behaviour.args.layout.values[_name] = _data.Name
	end
end

function sRaidFrames:CreateLayoutOptions(data, i)
	self.options.args.layouts.args[data.intname] = {
		name = data.name,
		type = "group",
		desc = L["Configure "]..data.name,
		args = {
			titlebar = {
				name = L["Title bar"],
				type = "group",
				desc = string.format(L["Configure this layout's %s bar"], L["title"]),
				order = 1,
				args = {
					height = {
						name = L["Height"],
						type = "input",
						desc = string.format(L["Modify the %s of this layout's %s bar"], L["height"], L["title"]),
						get = function() return tostring(self.opt.Layouts[i].title.height) or "16" end,
						set = function(info, value) self.opt.Layouts[i].title.height = tonumber(value); self:LayoutUpdate(i); end,
						order = 1,
					},
					width = {
						name = L["Width"],
						type = "input",
						desc = string.format(L["Modify the %s of this layout's %s bar"], L["width"], L["title"]),
						get = function() return tostring(self.opt.Layouts[i].title.width) or "80" end,
						set = function(info, value) self.opt.Layouts[i].title.width = tonumber(value); self:LayoutUpdate(i); end,
						order = 2,
					},
					offsets = {
						name = L["Offsets"],
						type = "group",
						desc = string.format(L["Modify the %s of this layout's %s bar"], L["offsets"], L["title"]),
						dialogInline = true,
						order = 3,
						args = {
							x = {
								name = "X",
								type = "input",
								desc = string.format(L["Modify the %s of this layout's %s bar"], "X "..L["offset"], L["title"]),
								get = function() return tostring(sRaidFrames.opt.Layouts[i].title.offsetx) or "0" end,
								set = function(info, value) sRaidFrames.opt.Layouts[i].title.offsetx = tonumber(value); self:LayoutUpdate(i); end,
								order = 1,
							},
							y = {
								name = "Y",
								type = "input",
								desc = string.format(L["Modify the %s of this layout's %s bar"], "Y "..L["offset"], L["title"]),
								get = function() return tostring(sRaidFrames.opt.Layouts[i].title.offsety) or "0" end,
								set = function(info, value) sRaidFrames.opt.Layouts[i].title.offsety = tonumber(value); self:LayoutUpdate(i); end,
								order = 1,
							},
						},
					},
				},
			},
			hpbar = {
				name = L["HP bar"],
				type = "group",
				desc = string.format(L["Configure this layout's %s bar"], L["HP"]),
				order = 2,
				args = {
					height = {
						name = L["Height"],
						type = "input",
						desc = string.format(L["Modify the %s of this layout's %s bar"], L["height"], L["HP"]),
						get = function() return tostring(sRaidFrames.opt.Layouts[i].hpbar.height) or "12" end,
						set = function(info, value) sRaidFrames.opt.Layouts[i].hpbar.height = tonumber(value); self:LayoutUpdate(i); end,
						order = 1,
					},
					width = {
						name = L["Width"],
						type = "input",
						desc = string.format(L["Modify the %s of this layout's %s bar"], L["width"], L["HP"]),
						get = function() return tostring(sRaidFrames.opt.Layouts[i].hpbar.width) or "80" end,
						set = function(info, value) sRaidFrames.opt.Layouts[i].hpbar.width = tonumber(value); self:LayoutUpdate(i); end,
						order = 2,
					},
					offsets = {
						name = L["Offsets"],
						type = "group",
						dialogInline = true,
						desc = string.format(L["Modify the %s of this layout's %s bar"], L["offsets"], L["HP"]),
						order = 3,
						args = {
							x = {
								name = "X",
								type = "input",
								desc = string.format(L["Modify the %s of this layout's %s bar"], "X "..L["offset"], L["HP"]),
								get = function() return tostring(sRaidFrames.opt.Layouts[i].hpbar.offsetx) or "0" end,
								set = function(info, value) sRaidFrames.opt.Layouts[i].hpbar.offsetx = tonumber(value); self:LayoutUpdate(i); end,
								order = 1,
							},
							y = {
								name = "Y",
								type = "input",
								desc = string.format(L["Modify the %s of this layout's %s bar"], "Y "..L["offset"], L["HP"]),
								get = function() return tostring(sRaidFrames.opt.Layouts[i].hpbar.offsety) or "0" end,
								set = function(info, value) sRaidFrames.opt.Layouts[i].hpbar.offsety = tonumber(value); self:LayoutUpdate(i); end,
								order = 2,
							},
						},
					},
				},
			},
			mpbar = {
				name = L["Mana bar"],
				type = "group",
				desc = string.format(L["Configure this layout's %s bar"], L["Mana"]),
				order = 3,
				args = {
					height = {
						name = L["Height"],
						type = "input",
						desc = string.format(L["Modify the %s of this layout's %s bar"], L["height"], L["Mana"]),
						get = function() return tostring(sRaidFrames.opt.Layouts[i].mpbar.height) or "4" end,
						set = function(info, value) sRaidFrames.opt.Layouts[i].mpbar.height = tonumber(value); self:LayoutUpdate(i); end,
					},
				},
			},
			buffsdebuffs = {
				name = L["Buffs & Debuffs"],
				type = "group",
				order = 4,
				desc = string.format(L["Configure this layout's %s"], L["Buffs & Debuffs"]),
				args = {
					anchor = {
						name = L["Anchor"],
						type = "select",
						desc = string.format(L["Configure the %s of this layout's %s"], L["anchor"], L["Buffs & Debuffs"]),
						get = function() return sRaidFrames.opt.Layouts[i].debuff.anchor or "TOPRIGHT" end,
						set = function(info, value) sRaidFrames.opt.Layouts[i].debuff.anchor = value; self:LayoutUpdate(i); end,
						values = {["TOPRIGHT"] = L["Top right"], ["TOPLEFT"] = L["Top left"], ["BOTTOMRIGHT"] = L["Bottom right"], ["BOTTOMLEFT"] = L["Bottom left"]},
						order = 1,
					},
					offsets = {
						name = L["Offsets"],
						type = "group",
						desc = string.format(L["Configure the %s of this layout's %s"], L["offsets"], L["Buffs & Debuffs"]),
						dialogInline = true,
						order = 2,
						args = {
							x = {
								name = "X",
								type = "input",
								desc = string.format(L["Configure the %s of this layout's %s"], "X "..L["offset"], L["Buffs & Debuffs"]),
								order = 1,
								get = function() return tostring(sRaidFrames.opt.Layouts[i].debuff.offsetx) end,
								set = function(info, value) sRaidFrames.opt.Layouts[i].debuff.offsetx = tonumber(value); self:LayoutUpdate(i); end,
							},
							y = {
								name = "Y",
								type = "input",
								desc = string.format(L["Configure the %s of this layout's %s"], "Y "..L["offset"], L["Buffs & Debuffs"]),
								order = 2,
								get = function() return tostring(sRaidFrames.opt.Layouts[i].debuff.offsety) end,
								set = function(info, value) sRaidFrames.opt.Layouts[i].debuff.offsety = tonumber(value); self:LayoutUpdate(i); end,
							},
						},
					},
					buffs = {
						name = L["Buffs"],
						type = "group",
						desc = string.format(L["Configure this layout's %s"], L["Buffs"]),
						args = {
							width = {
								name = L["Width"],
								type = "input",
								desc = string.format(L["Modify the %s of this layout's %s"], L["width"], L["Buffs"]),
								get = function() return tostring(sRaidFrames.opt.Layouts[i].buff.width) or "12" end,
								set = function(info, value) sRaidFrames.opt.Layouts[i].buff.width = tonumber(value); self:LayoutUpdate(i); end,
							},
							height = {
								name = L["Height"],
								type = "input",
								desc = string.format(L["Modify the %s of this layout's %s"], L["height"], L["Buffs"]),
								get = function() return tostring(sRaidFrames.opt.Layouts[i].buff.height) or "12" end,
								set = function(info, value) sRaidFrames.opt.Layouts[i].buff.height = tonumber(value); self:LayoutUpdate(i); end,
							},
						},
					},
					debuffs = {
						name = L["Debuffs"],
						type = "group",
						desc = string.format(L["Configure this layout's %s"], L["Debuffs"]),
						args = {
							width = {
								name = L["Width"],
								type = "input",
								desc = string.format(L["Modify the %s of this layout's %s"], L["width"], L["Debuffs"]),
								get = function() return tostring(sRaidFrames.opt.Layouts[i].debuff.width) or "16" end,
								set = function(info, value) sRaidFrames.opt.Layouts[i].debuff.width = value; self:LayoutUpdate(i); end,
							},
							height = {
								name = L["Height"],
								type = "input",
								desc = string.format(L["Modify the %s of this layout's %s"], L["height"], L["Debuffs"]),
								get = function() return tostring(sRaidFrames.opt.Layouts[i].debuff.height) or "16" end,
								set = function(info, value) sRaidFrames.opt.Layouts[i].debuff.height = value; self:LayoutUpdate(i); end,
							},
						},
					},
				},
			},
			font = {
				name = L["Status Text"],
				type = "group",
				desc = string.format(L["Modify this layout's %s"], L["Status text"]),
				order = 5,
				args = {
					font = {
						name = L["Font"],
						type = "select",
						desc = string.format(L["Modify the %s of this layout's %s"], L["Font"], L["Status text"]),
						get = function() return sRaidFrames.opt.Layouts[i].font.font end,
						set = function(info, value) sRaidFrames.opt.Layouts[i].font.font = value; self:LayoutUpdate(i); end,
						values = Media:HashTable("font"),
						dialogControl = "LSM30_Font",
						order = 1,
					},
					fontscale = {
						name = L["Font scale"],
						type = "range",
						desc = string.format(L["Modify the %s of this layout's %s"], L["Font scale"], L["Status text"]),
						min = 1,
						max = 50,
						step = 1,
						get = function() return sRaidFrames.opt.Layouts[i].font.scale end,
						set = function(info, value) sRaidFrames.opt.Layouts[i].font.scale = value; self:LayoutUpdate(i); end,
						order = 2,
					},
					fontoutline = {
						name = L["Font outline"],
						type = "select",
						desc = string.format(L["Modify the %s of this layout's %s"], L["Font outline"], L["Status text"]),
						values = {["OUTLINE"] = L["Outline"], ["THICKOUTLINE"] = L["Thick outline"], ["MONOCHROME"] = L["Monochrome"], [""] = L["None"]},
						get = function() return sRaidFrames.opt.Layouts[i].font.outline end,
						set = function(info, value) sRaidFrames.opt.Layouts[i].font.outline = value; self:LayoutUpdate(i); end,
						order = 3,
					},
				},
			},
			indicator = {
				name = L["Indicators"],
				type = "group",
				desc = string.format(L["Modify this layout's %s"], L["Indicators"]),
				order = 6,
				args = {
					scale = {
						name = L["Scale"],
						type = "range",
						desc = string.format(L["Modify the %s of this layout's %s"], L["scale"], L["Indicators"]),
						min = 0.1,
						max = 2.0,
						get = function() return sRaidFrames.opt.Layouts[i].indicator.scale end,
						set = function(info, value) sRaidFrames.opt.Layouts[i].indicator.scale = value; self:LayoutUpdate(i); end,
						isPercent = true,
					},
				},
			},
			border = {
				name = L["Border"],
				type = "toggle",
				desc = L["Select whether this layout uses a border"],
				get = function() return sRaidFrames.opt.Layouts[i].border or false end,
				set = function(info, value) sRaidFrames.opt.Layouts[i].border = value; self:LayoutUpdate(i); end,
				order = 1,
			},
			bordertexture = {
				name = L["Border texture"],
				type = "select",
				desc = string.format(L["Configure this layout's %s"], L["Border texture"]),
				get = function()
					return sRaidFrames.opt.Layouts[i].bordertexture
				end,
				set = function(info, value)
					sRaidFrames.opt.Layouts[i].bordertexture = value
					if not sRaidFrames.opt.Layout == sRaidFrames.opt.Layouts[i].intname then return end
					local tex = Media:Fetch("border", sRaidFrames.opt.Layouts[i].bordertexture)
					for _, frame in pairs(sRaidFrames.frames) do
						local backdrop = frame:GetBackdrop()
						backdrop.edgeFile = tex
						frame:SetBackdrop(backdrop)
					end
					sRaidFrames:UpdateAllUnits()
				end,
				values = AceGUIWidgetLSMlists.border,
				order = 2,
				dialogControl = 'LSM30_Border',
			},
		},
	}
end

function sRaidFrames:GetLayoutDefaults(name)
	local a= {
		bordertexture = sRaidFrames.opt.BorderTexture,
		border = false,
		name = name,
		intname = string.gsub(string.lower(name), " ", ""),
		debuff = {
			width = 16,
			height = 16,
			anchor = "TOPRIGHT",
			offsetx = 0,
			offsety = 0,
		},
		buff = {
			width = 12,
			height = 12,
		},
		title = {
			width = 80,
			height = 16,
			offsetx = 0,
			offsety = 0,
		},
		mpbar = {
			height = 4,
		},
		hpbar = {
			height = 12,
			width = 80,
			offsetx = 0,
			offsety = 0,
		},
		font = {
			font = "Friz Quadrata TT",
			scale = 10.000000140577,
			outline = "",
		},
		indicator = {
			scale = 1,
		},
	}
	return a
end
local function TableCompare(stable, default)
	for x, k in pairs(default) do
		if type(k)=="table" then
			if not stable[x] then stable[x] = {}; end
			stable[x] = TableCompare(stable[x], default[x]);
		else
			if not stable[x] then stable[x] = default[x] end
		end
	end
	return stable
end

function sRaidFrames:VerifyLayout(layout)
	if not layout.name then return end
	local default = sRaidFrames:GetLayoutDefaults(layout.name)
	return TableCompare(layout, default)
end

function sRaidFrames:CreateLayout(name)
	local i = #sRaidFrames.opt.Layouts+1;
	sRaidFrames.opt.Layouts[i] = self:GetLayoutDefaults(name);
	local data = sRaidFrames.opt.Layouts[i];
	sRaidFrames:RegisterLayout(data.intname, {
		Name = data.name,
		HasBorders = data.border,
		StyleUnitFrame = function(f)
			sRaidFrames:SetWHP(f, data.border and data.title.width+10 or data.title.width, ((data.debuff.anchor=="BOTTOMLEFT" or data.debuff.anchor=="BOTTOMRIGHT") and (data.mpbar.height+data.hpbar.height+math.max(data.debuff.height, data.buff.height)+data.title.height) or (data.mpbar.height+data.hpbar.height+data.title.height))+(data.border and 10 or 0));
			sRaidFrames:SetWHP(f.title, data.title.width, data.title.height, "TOPLEFT", f, "TOPLEFT", data.border and data.title.offsetx+5 or data.title.offsetx, data.border and data.title.offsety-4 or data.title.offsety)
			sRaidFrames:SetWHP(f.aura1, data.debuff.width, data.debuff.height, data.debuff.anchor, f, data.debuff.anchor, ((data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT")) and -4 or data.border and 4 or 0)+(data.debuff.offsetx or 0), ((data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="TOPLEFT")) and -4 or data.border and 4 or 0)+(data.debuff.offsety or 0))
			sRaidFrames:SetWHP(f.aura2, data.debuff.width, data.debuff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.aura1, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
			if sRaidFrames.opt.BuffType == "both" then
				local parent
				if f.aura2:IsShown() then
					parent = f.aura2
				elseif f.aura1:IsShown() then
					parent = f.aura1
				end
				if parent then
					sRaidFrames:SetWHP(f.buff1, data.buff.width, data.buff.height, data.debuff.anchor, parent, data.debuff.anchor=="TOPRIGHT" and "TOPLEFT" or data.debuff.anchor=="TOPLEFT" and "TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT" and "BOTTOMLEFT" or data.debuff.anchor=="BOTTOMLEFT" and "BOTTOMRIGHT", 0, 0)
				else
					sRaidFrames:SetWHP(f.buff1, data.buff.width, data.buff.height, data.debuff.anchor, f, data.debuff.anchor, ((data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT")) and -4 or data.border and 4 or 0)+(data.debuff.offsetx or 0), ((data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT")) and -4 or data.border and 4 or 0)+(data.debuff.offsety or 0))
				end
			else
				sRaidFrames:SetWHP(f.buff1, data.buff.width, data.buff.height, data.debuff.anchor, f, data.debuff.anchor, ((data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT")) and -4 or data.border and 4 or 0)+(data.debuff.offsetx or 0), ((data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="TOPLEFT")) and -4 or data.border and 4 or 0)+(data.debuff.offsety or 0))
			end
			sRaidFrames:SetWHP(f.buff2, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff1, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
			sRaidFrames:SetWHP(f.buff3, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff2, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
			sRaidFrames:SetWHP(f.buff4, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff3, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
			sRaidFrames:SetWHP(f.hpbar, data.hpbar.width, data.hpbar.height, "TOPLEFT", f.title, "BOTTOMLEFT", data.hpbar.offsetx, data.hpbar.offsety)
			sRaidFrames:SetWHP(f.mpbar, data.hpbar.width, data.mpbar.height, "TOPLEFT", f.hpbar, "BOTTOMLEFT", 0, 0)
			sRaidFrames:SetWHP(f.hpbar.text, f.hpbar:GetWidth(), f.hpbar:GetHeight(), "CENTER", f.hpbar, "CENTER", 0, 0)
			sRaidFrames:SetWHP(f.statustext, f.mpbar:GetWidth(), f.mpbar:GetHeight(), "CENTER", f.mpbar, "CENTER", 0, 0)
			f:SetBackdrop(data.border and { bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
									tile = true,
									tileSize = 16,
									edgeFile = Media:Fetch("border", data.bordertexture),
									edgeSize = 16,
									insets = { left = 5, right = 5, top = 5, bottom = 5 }
								} or { bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
										tile = true, tileSize = 16,
										insets = { left = 0, right = 0, top = 0, bottom = 0 }
									})
			f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
			f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
			f.statustext:SetFont(Media:Fetch("font", data.font.font), data.font.scale, data.font.outline)
			sRaidFrames:SetWHP(f.indicator_tl, 8*(data.indicator.scale or 1), 8*(data.indicator.scale or 1), "TOPLEFT", f, "TOPLEFT", -1*(data.indicator.scale or 1), 1*(data.indicator.scale or 1))
			sRaidFrames:SetWHP(f.indicator_tr, 8*(data.indicator.scale or 1), 8*(data.indicator.scale or 1), "TOPRIGHT", f, "TOPRIGHT", 1*(data.indicator.scale or 1), 1*(data.indicator.scale or 1));
			sRaidFrames:SetWHP(f.indicator_bl, 8*(data.indicator.scale or 1), 8*(data.indicator.scale or 1), "BOTTOMLEFT", f, "BOTTOMLEFT", -1*(data.indicator.scale or 1), -1*(data.indicator.scale or 1))
			sRaidFrames:SetWHP(f.indicator_br, 8*(data.indicator.scale or 1), 8*(data.indicator.scale or 1), "BOTTOMRIGHT", f, "BOTTOMRIGHT", 1*(data.indicator.scale or 1), -1*(data.indicator.scale or 1))
		end,
		unitframeWidth = data.border and data.title.width+10 or data.title.width,
		unitframeHeight =  ((data.debuff.anchor=="BOTTOMLEFT" or data.debuff.anchor=="BOTTOMRIGHT") and (data.mpbar.height+data.hpbar.height+math.max(data.debuff.height, data.buff.height)+data.title.height) or (data.mpbar.height+data.hpbar.height+data.title.height))+(data.border and 10 or 0),
		headerWidth = data.border and data.title.width+10 or data.title.width,
		headerHeight = 15, -- needs more testing
		debuffCount = 2,
		buffCount = 4,
	})
	self:CreateLayoutOptions(data, i);
end

function sRaidFrames:LayoutUpdate(i)
	local data = sRaidFrames.opt.Layouts[i]
	self:CreateLayoutOptions(data, i)
	self.options.args.behaviour.args.layout.values = {}
	for _name, _data in pairs(self.Layouts) do
		self.options.args.behaviour.args.layout.values[_name] = _data.Name
	end
	if data.intname == sRaidFrames.opt.Layout then self:ApplyLayout() end
end

function sRaidFrames:SetLayout(name)
	if not self.Layouts[name] then
		return
	end
	self.opt.Layout = name
	self.CurrentLayout = self.Layouts[name]
end

function sRaidFrames:ApplyLayout()
	for _, f in ipairs(self.frames) do
		self:GetLayout().StyleUnitFrame(f)
	end
	for unit in pairs(self:GetAllUnits()) do
		self:UpdateStatuses(unit)
	end
	self:SetSpacing()
end

function sRaidFrames:GetCurrentCustomLayoutID()
	local name = self:GetLayout()["Name"];
	for i, k in pairs(self.opt.Layouts) do
		if k["name"] == name then
			return i
		end
	end
end

function sRaidFrames:GetLayout()
	if not self.CurrentLayout then
		self:SetLayout(self.opt.Layout)
	end
	return self.CurrentLayout
end

sRaidFrames:RegisterLayout("CTRA_WithBorders", {
	Name = L["CT_RaidAssist"],
	HasBorders = true,
	StyleUnitFrame = function(f)
		sRaidFrames:SetWHP(f, 90, 40)
		sRaidFrames:SetWHP(f.title, 80, 16, "TOPLEFT", f, "TOPLEFT",  5, -4)
		sRaidFrames:SetWHP(f.aura1, 16, 16, "TOPRIGHT", f, "TOPRIGHT", -4, -4)
		sRaidFrames:SetWHP(f.aura2, 16, 16, "RIGHT", f.aura1, "LEFT", 0, 0)
		if sRaidFrames.opt.BuffType == "both" then
			sRaidFrames:SetWHP(f.buff1, 12, 12, "TOPRIGHT", f.aura2,"TOPLEFT", 0, 0);
		else
			sRaidFrames:SetWHP(f.buff1, 12, 12, "TOPRIGHT", f, "TOPRIGHT", -4, -4)
		end
		sRaidFrames:SetWHP(f.buff2, 12, 12, "RIGHT", f.buff1, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff3, 12, 12, "RIGHT", f.buff2, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff4, 12, 12, "RIGHT", f.buff3, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.hpbar, 80, 12, "TOPLEFT", f.title, "BOTTOMLEFT", 0, 0)
		sRaidFrames:SetWHP(f.mpbar, 80, 4, "TOPLEFT", f.hpbar, "BOTTOMLEFT", 0, 0)
	
		sRaidFrames:SetWHP(f.hpbar.text, f.hpbar:GetWidth(), f.hpbar:GetHeight(), "CENTER", f.hpbar, "CENTER", 0, 0)
		sRaidFrames:SetWHP(f.statustext, f.mpbar:GetWidth(), f.mpbar:GetHeight(), "CENTER", f.mpbar, "CENTER", 0, 0)
		
		
		f:SetBackdrop({ bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
									tile = true,
									tileSize = 16,
									edgeFile = Media:Fetch("border", sRaidFrames.opt.BorderTexture),
									edgeSize = 16,
									insets = { left = 5, right = 5, top = 5, bottom = 5 }
								})
								
		f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
		f:SetBackdropBorderColor(sRaidFrames.opt.BorderColor.r, sRaidFrames.opt.BorderColor.g, sRaidFrames.opt.BorderColor.b, sRaidFrames.opt.BorderColor.a)
		f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
		f.statustext:SetFont("Fonts\\FRIZQT__.TTF", 10.000000140577, "")
		sRaidFrames:SetWHP(f.indicator_tl, 8, 8, "TOPLEFT", f, "TOPLEFT", -1, 1)
		sRaidFrames:SetWHP(f.indicator_tr, 8, 8, "TOPRIGHT", f, "TOPRIGHT", 1, 1);
		sRaidFrames:SetWHP(f.indicator_bl, 8, 8, "BOTTOMLEFT", f, "BOTTOMLEFT", -1, -1)
		sRaidFrames:SetWHP(f.indicator_br, 8, 8, "BOTTOMRIGHT", f, "BOTTOMRIGHT", 1, -1)
	end,
	unitframeWidth = 90,
	unitframeHeight = 40,
	headerWidth = 90,
	headerHeight = 15,
	debuffCount = 2,
	buffCount = 4,
})

sRaidFrames:RegisterLayout("CTRA_NoBorders", {
	Name = L["CT_RaidAssist (Without Borders)"],
	HasBorders = false,
	StyleUnitFrame = function(f)
		sRaidFrames:SetWHP(f, 80, 32)
		sRaidFrames:SetWHP(f.title, 80, 16, "TOPLEFT", f, "TOPLEFT",  0, 0)
		sRaidFrames:SetWHP(f.aura1, 16, 16, "TOPRIGHT", f, "TOPRIGHT", 0, 0)
		sRaidFrames:SetWHP(f.aura2, 16, 16, "RIGHT", f.aura1, "LEFT", 0, 0)
		if sRaidFrames.opt.BuffType == "both" then
			sRaidFrames:SetWHP(f.buff1, 12, 12, "TOPRIGHT", f.aura2, "TOPLEFT", 0, 0);
		else
			sRaidFrames:SetWHP(f.buff1, 12, 12, "TOPRIGHT", f, "TOPRIGHT", 0, 0)
		end
		sRaidFrames:SetWHP(f.buff2, 12, 12, "RIGHT", f.buff1, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff3, 12, 12, "RIGHT", f.buff2, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff4, 12, 12, "RIGHT", f.buff3, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.hpbar, 80, 12, "TOPLEFT", f.title, "BOTTOMLEFT", 0, 0)
		sRaidFrames:SetWHP(f.mpbar, 80, 4, "TOPLEFT", f.hpbar, "BOTTOMLEFT", 0, 0)
	
		sRaidFrames:SetWHP(f.hpbar.text, f.hpbar:GetWidth(), f.hpbar:GetHeight(), "CENTER", f.hpbar, "CENTER", 0, 0)
		sRaidFrames:SetWHP(f.statustext, f.mpbar:GetWidth(), f.mpbar:GetHeight(), "CENTER", f.mpbar, "CENTER", 0, 0)
		
		f:SetBackdrop({ bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
										tile = true, tileSize = 16,
										insets = { left = 0, right = 0, top = 0, bottom = 0 }
									})
		
		f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
		f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
		f.statustext:SetFont("Fonts\\FRIZQT__.TTF", 10.000000140577, "")
		sRaidFrames:SetWHP(f.indicator_tl, 8, 8, "TOPLEFT", f, "TOPLEFT", -1, 1)
		sRaidFrames:SetWHP(f.indicator_tr, 8, 8, "TOPRIGHT", f, "TOPRIGHT", 1, 1);
		sRaidFrames:SetWHP(f.indicator_bl, 8, 8, "BOTTOMLEFT", f, "BOTTOMLEFT", -1, -1)
		sRaidFrames:SetWHP(f.indicator_br, 8, 8, "BOTTOMRIGHT", f, "BOTTOMRIGHT", 1, -1)
	end,
	unitframeWidth = 80,
	unitframeHeight = 32,
	headerWidth = 80,
	headerHeight = 15,
	debuffCount = 2,
	buffCount = 4,
})

sRaidFrames:RegisterLayout("CTRA_NoBordersWide", {
	Name = L["CT_RaidAssist (Without borders, Wide)"],
	HasBorders = false,
	StyleUnitFrame = function(f)
		sRaidFrames:SetWHP(f, 90, 40)
		sRaidFrames:SetWHP(f.title, 80, 16, "TOPLEFT", f, "TOPLEFT",  5, -4)
		sRaidFrames:SetWHP(f.aura1, 16, 16, "TOPRIGHT", f, "TOPRIGHT", -4, -4)
		sRaidFrames:SetWHP(f.aura2, 16, 16, "RIGHT", f.aura1, "LEFT", 0, 0)
		if sRaidFrames.opt.BuffType == "both" then
			sRaidFrames:SetWHP(f.buff1, 12, 12, "TOPRIGHT", f.aura2, "TOPLEFT", 0, 0);
		else
			sRaidFrames:SetWHP(f.buff1, 12, 12, "TOPRIGHT", f, "TOPRIGHT", -4, -4)
		end
		sRaidFrames:SetWHP(f.buff2, 12, 12, "RIGHT", f.buff1, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff3, 12, 12, "RIGHT", f.buff2, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff4, 12, 12, "RIGHT", f.buff3, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.hpbar, 80, 12, "TOPLEFT", f.title, "BOTTOMLEFT", 0, 0)
		sRaidFrames:SetWHP(f.mpbar, 80, 4, "TOPLEFT", f.hpbar, "BOTTOMLEFT", 0, 0)
	
		sRaidFrames:SetWHP(f.hpbar.text, f.hpbar:GetWidth(), f.hpbar:GetHeight(), "CENTER", f.hpbar, "CENTER", 0, 0)
		sRaidFrames:SetWHP(f.statustext, f.mpbar:GetWidth(), f.mpbar:GetHeight(), "CENTER", f.mpbar, "CENTER", 0, 0)
		
		
		f:SetBackdrop({ bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
										tile = true, tileSize = 16,
										insets = { left = 0, right = 0, top = 0, bottom = 0 }
									})
								
		f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
		f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
		f.statustext:SetFont("Fonts\\FRIZQT__.TTF", 10.000000140577, "")
		sRaidFrames:SetWHP(f.indicator_tl, 8, 8, "TOPLEFT", f, "TOPLEFT", -1, 1)
		sRaidFrames:SetWHP(f.indicator_tr, 8, 8, "TOPRIGHT", f, "TOPRIGHT", 1, 1);
		sRaidFrames:SetWHP(f.indicator_bl, 8, 8, "BOTTOMLEFT", f, "BOTTOMLEFT", -1, -1)
		sRaidFrames:SetWHP(f.indicator_br, 8, 8, "BOTTOMRIGHT", f, "BOTTOMRIGHT", 1, -1)
	end,
	unitframeWidth = 90,
	unitframeHeight = 40,
	headerWidth = 90,
	headerHeight = 15,
	debuffCount = 2,
	buffCount = 4,
})
function sRaidFrames:RegisterCustomLayouts()
	for i=1, #sRaidFrames.opt.Layouts do
		sRaidFrames.opt.Layouts[i] = self:VerifyLayout(sRaidFrames.opt.Layouts[i])
		local data = sRaidFrames.opt.Layouts[i]
		if data then
			sRaidFrames:RegisterLayout(data.intname, {
				Name = data.name,
				HasBorders = data.border,
				StyleUnitFrame = function(f)
					sRaidFrames:SetWHP(f, data.border and data.title.width+10 or data.title.width,  ((data.debuff.anchor=="BOTTOMLEFT" or data.debuff.anchor=="BOTTOMRIGHT") and (data.mpbar.height+data.hpbar.height+math.max(data.debuff.height, data.buff.height)+data.title.height) or (data.mpbar.height+data.hpbar.height+data.title.height))+(data.border and 10 or 0));
					sRaidFrames:SetWHP(f.title, data.title.width, data.title.height, "TOPLEFT", f, "TOPLEFT", data.border and data.title.offsetx+5 or data.title.offsetx, data.border and data.title.offsety-4 or data.title.offsety)
					sRaidFrames:SetWHP(f.aura1, data.debuff.width, data.debuff.height, data.debuff.anchor, f, data.debuff.anchor, ((data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT")) and -4 or data.border and 4 or 0)+(data.debuff.offsetx or 0), ((data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="TOPLEFT")) and -4 or data.border and 4 or 0)+(data.debuff.offsety or 0))
					sRaidFrames:SetWHP(f.aura2, data.debuff.width, data.debuff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.aura1, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
					if sRaidFrames.opt.BuffType == "both" then
						local parent
						if f.aura2:IsShown() then
							parent = f.aura2
						elseif f.aura1:IsShown() then
							parent = f.aura1
						end
						if parent then
							sRaidFrames:SetWHP(f.buff1, data.buff.width, data.buff.height, data.debuff.anchor, parent, data.debuff.anchor=="TOPRIGHT" and "TOPLEFT" or data.debuff.anchor=="TOPLEFT" and "TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT" and "BOTTOMLEFT" or data.debuff.anchor=="BOTTOMLEFT" and "BOTTOMRIGHT", 0, 0)
						else
							sRaidFrames:SetWHP(f.buff1, data.buff.width, data.buff.height, data.debuff.anchor, f, data.debuff.anchor, ((data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT")) and -4 or data.border and 4 or 0)+(data.debuff.offsetx or 0), ((data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT")) and -4 or data.border and 4 or 0)+(data.debuff.offsety or 0))
						end
					else
						sRaidFrames:SetWHP(f.buff1, data.buff.width, data.buff.height, data.debuff.anchor, f, data.debuff.anchor, ((data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="BOTTOMRIGHT")) and -4 or data.border and 4 or 0)+(data.debuff.offsetx or 0), ((data.border and (data.debuff.anchor=="TOPRIGHT" or data.debuff.anchor=="TOPLEFT")) and -4 or data.border and 4 or 0)+(data.debuff.offsety or 0))
					end
					sRaidFrames:SetWHP(f.buff2, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff1, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
					sRaidFrames:SetWHP(f.buff3, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff2, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
					sRaidFrames:SetWHP(f.buff4, data.buff.width, data.buff.height, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "LEFT" or "RIGHT", f.buff3, (data.debuff.anchor=="TOPLEFT" or data.debuff.anchor=="BOTTOMLEFT") and "RIGHT" or "LEFT", 0, 0)
					sRaidFrames:SetWHP(f.hpbar, data.hpbar.width, data.hpbar.height, "TOPLEFT", f.title, "BOTTOMLEFT", data.hpbar.offsetx, data.hpbar.offsety)
					sRaidFrames:SetWHP(f.mpbar, data.hpbar.width, data.mpbar.height, "TOPLEFT", f.hpbar, "BOTTOMLEFT", 0, 0)
					sRaidFrames:SetWHP(f.hpbar.text, f.hpbar:GetWidth(), f.hpbar:GetHeight(), "CENTER", f.hpbar, "CENTER", 0, 0)
					sRaidFrames:SetWHP(f.statustext, f.mpbar:GetWidth(), f.mpbar:GetHeight(), "CENTER", f.mpbar, "CENTER", 0, 0)
					f:SetBackdrop(data.border and { bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
											tile = true,
											tileSize = 16,
											edgeFile = Media:Fetch("border", data.bordertexture),
											edgeSize = 16,
											insets = { left = 5, right = 5, top = 5, bottom = 5 }
										} or { bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
												tile = true, tileSize = 16,
												insets = { left = 0, right = 0, top = 0, bottom = 0 }
											})
					f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
					f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
					f.statustext:SetFont(Media:Fetch("font", data.font.font), data.font.scale, data.font.outline)
					sRaidFrames:SetWHP(f.indicator_tl, 8*(data.indicator.scale or 1), 8*(data.indicator.scale or 1), "TOPLEFT", f, "TOPLEFT", -1*(data.indicator.scale or 1), 1*(data.indicator.scale or 1))
					sRaidFrames:SetWHP(f.indicator_tr, 8*(data.indicator.scale or 1), 8*(data.indicator.scale or 1), "TOPRIGHT", f, "TOPRIGHT", 1*(data.indicator.scale or 1), 1*(data.indicator.scale or 1));
					sRaidFrames:SetWHP(f.indicator_bl, 8*(data.indicator.scale or 1), 8*(data.indicator.scale or 1), "BOTTOMLEFT", f, "BOTTOMLEFT", -1*(data.indicator.scale or 1), -1*(data.indicator.scale or 1))
					sRaidFrames:SetWHP(f.indicator_br, 8*(data.indicator.scale or 1), 8*(data.indicator.scale or 1), "BOTTOMRIGHT", f, "BOTTOMRIGHT", 1*(data.indicator.scale or 1), -1*(data.indicator.scale or 1))
				end,
				unitframeWidth = data.border and data.title.width+10 or data.title.width,
				unitframeHeight =  ((data.debuff.anchor=="BOTTOMLEFT" or data.debuff.anchor=="BOTTOMRIGHT") and (data.mpbar.height+data.hpbar.height+math.max(data.debuff.height, data.buff.height)+data.title.height) or (data.mpbar.height+data.hpbar.height+data.title.height))+(data.border and 10 or 0),
				headerWidth = data.border and data.title.width+10 or data.title.width,
				headerHeight = 15, -- needs more testing
				debuffCount = 2,
				buffCount = 4,
			})
			self:CreateLayoutOptions(data, i)
		end
	end
end
--[[
sRaidFrames:RegisterLayout("sRaidFrames", {
	Name = "sRaidFrames",
	HasBorders = true,
	StyleUnitFrame = function(f)
		sRaidFrames:SetWHP(f, 80, 30)
		sRaidFrames:SetWHP(f.title, 78, 13, "TOPLEFT", f, "TOPLEFT",  1, 0)
		sRaidFrames:SetWHP(f.aura1, 13, 13, "TOPRIGHT", f, "TOPRIGHT", -1, -1)
		sRaidFrames:SetWHP(f.aura2, 13, 13, "RIGHT", f.aura1, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff1, 13, 13, "TOPRIGHT", f, "TOPRIGHT", -1, -1)
		sRaidFrames:SetWHP(f.buff2, 13, 13, "RIGHT", f.buff1, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff3, 13, 13, "RIGHT", f.buff2, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.hpbar, 78, 12, "TOPLEFT", f.title, "BOTTOMLEFT", 0, 0)
		sRaidFrames:SetWHP(f.mpbar, 78, 4, "TOPLEFT", f.hpbar, "BOTTOMLEFT", 0, 0)
	
		sRaidFrames:SetWHP(f.hpbar.text, f.hpbar:GetWidth(), f.hpbar:GetHeight(), "CENTER", f.hpbar, "CENTER", 0, 0)
		sRaidFrames:SetWHP(f.statustext, f.mpbar:GetWidth(), f.mpbar:GetHeight(), "CENTER", f.mpbar, "CENTER", 0, 0)
		
		
		f:SetBackdrop({ bgFile = "Interface\\Addons\\sRaidFrames\\textures\\solidborder",
									tile = true,
									tileSize = 16,
									edgeFile = "Interface\\Addons\\sRaidFrames\\textures\\solidborder",
									edgeSize = 1,
									insets = { left = 1, right = 1, top = 1, bottom = 1 }
								})
								
		f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
		f:SetBackdropBorderColor(sRaidFrames.opt.BorderColor.r, sRaidFrames.opt.BorderColor.g, sRaidFrames.opt.BorderColor.b, sRaidFrames.opt.BorderColor.a)
		f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
	end,
	unitframeWidth = 80,
	unitframeHeight = 30,
	headerWidth = 85,
	headerHeight = 15,
	debuffCount = 2,
	buffCount = 3,
})



sRaidFrames:RegisterLayout("Grid", {
	Name = "Dispell Grid",
	HasBorders = false,
	StyleUnitFrame = function(f)
		sRaidFrames:SetWHP(f, 26, 26)
		sRaidFrames:SetWHP(f.title, 80, 16, "TOPLEFT", f, "TOPLEFT",  5, -4)
		
		sRaidFrames:SetWHP(f.aura1, 16, 16, "CENTER", f, "CENTER", 0, 0)
		
		sRaidFrames:SetWHP(f.buff1, 12, 12, "TOPRIGHT", f, "TOPRIGHT", -4, -4)
		sRaidFrames:SetWHP(f.buff2, 12, 12, "RIGHT", f.buff1, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff3, 12, 12, "RIGHT", f.buff2, "LEFT", 0, 0)
		sRaidFrames:SetWHP(f.buff4, 12, 12, "RIGHT", f.buff3, "LEFT", 0, 0)
		
		sRaidFrames:SetWHP(f.hpbar, 80, 12, "TOPLEFT", f, "TOPLEFT", 0, 0)
		sRaidFrames:SetWHP(f.mpbar, 80, 4, "TOPRIGHT", f, "TOPRIGHT", 0, 0)
		
		f.hpbar:Hide()
		f.mpbar:Hide()
	
		sRaidFrames:SetWHP(f.title, f:GetWidth()-4, f.hpbar:GetHeight(), "CENTER", f, "CENTER", 0, 0)
		
		f.title:SetJustifyH("CENTER")
		f.title:SetNonSpaceWrap(true)
		
		f:SetBackdropColor(sRaidFrames.opt.BackgroundColor.r, sRaidFrames.opt.BackgroundColor.g, sRaidFrames.opt.BackgroundColor.b, sRaidFrames.opt.BackgroundColor.a)
		f:SetBackdropBorderColor(sRaidFrames.opt.BorderColor.r, sRaidFrames.opt.BorderColor.g, sRaidFrames.opt.BorderColor.b, sRaidFrames.opt.BorderColor.a)
		f.hpbar.text:SetTextColor(sRaidFrames.opt.HealthTextColor.r, sRaidFrames.opt.HealthTextColor.g, sRaidFrames.opt.HealthTextColor.b, sRaidFrames.opt.HealthTextColor.a)
		
		f:SetBackdrop( {
				      bgFile = "Interface\\Addons\\sRaidFrames\\textures\\solidborder", tile = true, tileSize = 16,
				      edgeFile = "Interface\\Addons\\sRaidFrames\\textures\\solidborder", edgeSize = 1,
				      insets = {left = 1, right = 1, top = 1, bottom = 1},
			      })
	end,
	unitframeWidth = 26,
	unitframeHeight = 26,
	headerWidth = 26,
	headerHeight = 15,
	debuffCount = 1,
	buffCount = 4,
})
]]--